package Utopp.Objekte;
import java.util.Vector;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import Utopp.Komponenten.*;

public class ShowOB extends JDialog implements ActionListener
        {
        UmlObjekt ob_;

        int offsetX_ = 150;
        int offsetY_ = 50;
        int breite_ = 0;
        int breiteAttribNamen_ = 0;
        int breiteAttribWerte_ = 0;
        int hoehe_ = 0;
        int zeilenAbstand_ = 2;
        int randUnten_ = 10;
        int randOben_ = 5;
        int randLinks_ = 5;

        // Optische Einstellungen fr Multi-Objekt:
        int zusatzRahmenAbstand_ = 6;
        int zusatzRahmenAnzahl_ = 4;

        // Rahmendicke fr Aktives Objekt
        int rahmenDickeAktiv_ = 4;

        JButton okButton_ = new JButton("OK");
        JCheckBox showMBox_ = new JCheckBox("Methoden");
        JCheckBox showABox_ = new JCheckBox("Attribute");

        // Detail-Einstellungen
        boolean showMethoden_ = true;
        boolean showAttribute_ = false;

        public ShowOB(JFrame frame, boolean modal, UmlObjekt OB)
                {
                super(frame,"Darstellung der Klasse",modal);

                ob_ = OB;
                Container cp = getContentPane();

                if (ob_.getMulti())
                    {
                    offsetX_ = offsetX_ + zusatzRahmenAbstand_ * zusatzRahmenAnzahl_;
                    offsetY_ = offsetY_ + zusatzRahmenAbstand_ * zusatzRahmenAnzahl_;
                    }
                JPanel MainPanel = new JPanel();
                MainPanel.setLayout(null);

                okButton_.setBounds(20,offsetY_,60,30);
                okButton_.addActionListener(this);

                showABox_.setBounds(20,offsetY_ + 80, 80, 20);
                showABox_.addActionListener(this);

                /*showMBox_.setBounds(20,offsetY_ + 100, 80, 20);
                showMBox_.addActionListener(this);*/

                MainPanel.add(okButton_);
                //MainPanel.add(showMBox_);
                MainPanel.add(showABox_);
                cp.add(MainPanel);

                //Damit man das Fenster schliessen kann
                this.addWindowListener(
				new WindowAdapter()
					{
					public void windowClosed(WindowEvent e)
						{
                                                killYourself();
                                                }
					}
				);

                }


        private void killYourself()
                {
                this.setVisible(false);
                this.hide();
                }
        public void actionPerformed(ActionEvent event)
                {
                paint(this.getGraphics());
                String command = event.getActionCommand();
                if (command.equals("OK"))
                        {
                        //Beende Dialog
                        killYourself();
                        }


                }


        public void paint(Graphics g)
            {
            super.paint(g);

            showAttribute_ = showABox_.isSelected();
            //showMethoden_ = showMBox_.isSelected();
            // Fonts erzeugen
            Font defaultFont = new Font("Default",Font.PLAIN,14);
            Font namenFont = new Font("Default", Font.BOLD, 18);
            Font attrMethFont = new Font("Default", Font.BOLD, 14);

            // Datenstrukturen zur Ausmaberechnung anlegen
            FontMetrics fmDef = getFontMetrics(defaultFont);
            FontMetrics fmName = getFontMetrics(namenFont);
            FontMetrics fmAttrMeth = getFontMetrics(attrMethFont);




            // Lege leeren Vector fr die einzelnen Strings an
            Vector zeilen = new Vector();

            // erstelle Strings fr die einzelnen Zeilen





            // brige Zeilen: Attribute (Name + Wert)
            int attribAnzahl = 0;
            if (showAttribute_)
                {
                attribAnzahl = ob_.getAttributAnzahl();
                for (int i=0; i<attribAnzahl; i++)
                  {
                  zeilen.add(ob_.getAttribute(i).getName());
                  zeilen.add(ob_.getAttribute(i).getWert());
                  }
                }


            // Breiten ermitteln (der int-Vektor "breiten" enthlt danach die Zeilenbreiten)


            breiteAttribNamen_ = 0;
            breiteAttribWerte_ = 0;
            breite_ = fmName.stringWidth(ob_.getKlassenname()+" : "+ob_.getName());



            for (int i=0; i< attribAnzahl; i++)
                {
                int a = fmDef.stringWidth((String)zeilen.get(2 * i));
                if (breiteAttribNamen_ < a) breiteAttribNamen_ = a;
                a = fmDef.stringWidth((String)zeilen.get(2 * i + 1));
                if (breiteAttribWerte_ < a) breiteAttribWerte_ = a;
                }



            if (breiteAttribWerte_+breiteAttribNamen_+fmDef.stringWidth(" = ")>breite_)
                breite_ = breiteAttribWerte_+breiteAttribNamen_+fmDef.stringWidth(" = ");
            breite_ = breite_ + 2 * randLinks_;


            // Erstes Rechteck
            g.setFont(namenFont);
            int cursorY = offsetY_ + randOben_ + fmDef.getHeight();
            int cursorX = getCenterX(fmName.stringWidth(ob_.getKlassenname()+" : "+ob_.getName()));
            g.drawString(ob_.getKlassenname()+" : "+ob_.getName(),cursorX, cursorY);

            cursorY = cursorY + randUnten_;

            g.drawRect(offsetX_, offsetY_, breite_, cursorY - offsetY_);


            // Zweites Rechteck (Attribute)
            g.setFont(defaultFont);
            if (showAttribute_)
                {
                int oben = cursorY;
                cursorY = cursorY + randOben_;
                int bvg = fmDef.stringWidth(" = "); // Breite vom Gleichheitszeichen
                int rrvA = breiteAttribNamen_ + offsetX_ + randLinks_;  //rechter Rand vom Attribut-Namen

                for(int i=0; i < attribAnzahl; i++)
                    {
                    cursorY = cursorY + zeilenAbstand_ + fmDef.getHeight();
                    g.drawString((String)zeilen.get(2 * i), rrvA - fmDef.stringWidth((String)zeilen.get(2 * i)), cursorY);
                    g.drawString(" = ", rrvA, cursorY);
                    g.drawString((String)zeilen.get(2 * i + 1), rrvA + bvg, cursorY);
                    }

                cursorY = cursorY + randUnten_;
                g.drawRect(offsetX_, oben, breite_, cursorY - oben);
                }

                if (ob_.getAktiv())
                    for (int i=0; i<rahmenDickeAktiv_; i++)
                        g.drawRect(offsetX_ - i, offsetY_ - i,
                              breite_ + 2 * i, cursorY - offsetY_ + 2 * i);

                if (ob_.getMulti())
                    {
                    for (int i=0; i<zusatzRahmenAnzahl_; i++)
                        {
                        g.drawLine(offsetX_ + (i+1) * zusatzRahmenAbstand_, offsetY_ - i * zusatzRahmenAbstand_,
                            offsetX_ + (i+1) * zusatzRahmenAbstand_, offsetY_ - (i+1) * zusatzRahmenAbstand_);
                        g.drawLine(offsetX_ + (i+1) * zusatzRahmenAbstand_, offsetY_ - (i+1) * zusatzRahmenAbstand_,
                            offsetX_ + (i+1) * zusatzRahmenAbstand_ + breite_, offsetY_ - (i+1) * zusatzRahmenAbstand_);
                        g.drawLine(offsetX_ + (i+1) * zusatzRahmenAbstand_ + breite_, offsetY_ - (i+1) * zusatzRahmenAbstand_,
                            offsetX_ + (i+1) * zusatzRahmenAbstand_ + breite_, cursorY - (i+1) * zusatzRahmenAbstand_);
                        g.drawLine(offsetX_ + (i+1) * zusatzRahmenAbstand_ + breite_, cursorY - (i+1) * zusatzRahmenAbstand_,
                            offsetX_ + i * zusatzRahmenAbstand_ + breite_, cursorY - (i+1) * zusatzRahmenAbstand_);
                        }
                    }
                }

        // Diese Methode liefert bei Angabe der Zeilenbreite mithilfe der
        // Attribute breite_ und offsetX_ die x-Koordinate zurck, bei
        // der die Schrift beginnen mu, um zentriert zu stehen

        private int getCenterX(int zeilenBreite)
            {
            return offsetX_ + (breite_ - zeilenBreite)/2;
            }


        }



