package Utopp.UseCase;
/*

Version 1.0, 09.01.1 17:03.

8.12.2000

Autor: florian.wessels@math.uni-muenster.de

Diese Klasse malt eine Ellipse, in der zentriert ein Name steht.

*/

//import Komponenten.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import Utopp.*;
import Utopp.Komponenten.*;


public class UseCaseZeigen extends Frame {
        UmlUseCase usecase;

	String useCaseName;

  //public static void main(String[] args) {

    	//UseCaseZeigen wnd = new UseCaseZeigen("Schnecken schubsen");
    	//wnd.addWindowListener(new WindowClosingAdapter(true));
    	//wnd.setVisible(true);
//  }

public UseCaseZeigen(JFrame frame,boolean modal,UmlUseCase usecase) {

	//super("UseCase "+name);
	//super(frame,"Usecase Ausgabe", modal);
	this.usecase = usecase;
	this.setTitle("UseCase "+usecase.getName());
	
	useCaseName = usecase.getUC(1);

	Font font = new Font("Default",Font.PLAIN,14);
	FontMetrics fm = getFontMetrics(font);

	// Wie lang wird der String?
	int stw = fm.stringWidth(usecase.getName());

	addWindowListener(new WindowClosingAdapter(false));
	setBackground(Color.white);
	setSize(3*stw+23,2*stw+17);
	setVisible(true);

}

public void paint(Graphics g) {

	// Bestimme die Laenge des zu zeichnenden Strings:

	Font font = new Font("Default",Font.PLAIN,14);
	FontMetrics fm = getFontMetrics(font);
	int stw = fm.stringWidth(useCaseName);

	// Ermittle Fenstergroesse

	int breite = getSize().width-getInsets().right-getInsets().left;
  	int hoehe = getSize().height-getInsets().bottom-getInsets().top;
  	int xo = getInsets().left;
  	int yo = getInsets().top;

  	int mitteX = xo + breite/2;
  	int mitteY = yo + hoehe/2;

  	//Skalieren

  	int alpha = stw/5;
  	yo += alpha;
  	xo += alpha;
  	hoehe -= 2*alpha;
  	breite -= 2*alpha;

	g.drawOval(xo,yo,breite,hoehe);
   g.setFont(font);
   g.drawString(useCaseName, mitteX-stw/2, mitteY);

}}