package Utopp.Komponenten;
import java.util.Vector;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author
 * @version 1.0
 */

public class TestKomp {

  public TestKomp() {
  }
  public static void main(String[] args) {
    System.out.println("TEST PFLICHTENHEFT");
    Pflichtenheft ph = new Pflichtenheft("PH1");
    ph.setPHeft(0,"zielbest");
    ph.setPHeft(2,"wunschbest");
    System.out.println(ph.getName() + " " + ph.getPHeft(0)+ " " + ph.getPHeft(1) + " " + ph.getPHeft(2));

    System.out.println("TEST USECASE");
    UmlUseCase uuc = new UmlUseCase("UC1");
    uuc.setUC(0,"akteur");
    uuc.setUC(1,"vorbed");
    System.out.println(uuc.getName() + " " + uuc.getUC(0)+ " " + uuc.getUC(1) + " " + uuc.getUC(2));

    System.out.println("TEST KLASSENATTRIBUTE");
    UmlKlassenAttribut uka1 = new UmlKlassenAttribut("attribut1","int",0,false);
    UmlKlassenAttribut uka2 = new UmlKlassenAttribut("attribut2","bool",1,true);
    UmlKlassenAttribut uka3 = new UmlKlassenAttribut("attribut3","Klasse",2,false);
    Vector uka = new Vector();
    uka.addElement(uka1); uka.addElement(uka2); uka.addElement(uka3);

    System.out.println("TEST KLASSENPARAMETER");
    UmlKlassenParameter ukp1 = new UmlKlassenParameter("test1","int");
    UmlKlassenParameter ukp2 = new UmlKlassenParameter("test2","void");
    UmlKlassenParameter ukp3 = new UmlKlassenParameter("test3","String");
    Vector ukp = new Vector();
    ukp.addElement(ukp1); ukp.addElement(ukp2); ukp.addElement(ukp3);


    System.out.println("TEST KLASSENMETHODEN");
    UmlKlassenMethode ukm1 = new UmlKlassenMethode("meth1","int",ukp,0,false);
    UmlKlassenMethode ukm2 = new UmlKlassenMethode("meth2","double",ukp,0,true);
    Vector ukm = new Vector();
    ukm.addElement(ukm1); ukm.addElement(ukm2);

    System.out.println("TEST KLASSE");
    UmlKlasse uk = new UmlKlasse("Klasse1","Packet",ukm,uka,"Zusicherung","Stereo",false,0);
    System.out.println(uk.getString());

    System.out.println("TEST OBJEKT");
    UmlObjektAttribut uoa1 = new UmlObjektAttribut("radius","2");
    UmlObjektAttribut uoa2 = new UmlObjektAttribut("umfang","5.8");
    Vector uoa = new Vector();
    uoa.addElement(uoa1); uoa.addElement(uoa2);
    UmlObjekt uo = new UmlObjekt("einKreis",uoa,"Kreis",false,false);

    System.out.println("TEST VERBINDUNG");
    LinienTyp standardLinie= new LinienTyp(1,true);
    Endung leerEndung= new Endung("","",uuc);
    Endung linkEndung= new Endung("1..*","Rolle A",uk);
    EndungRaute aggregationRaute= new EndungRaute("1..*","Rolle A",uk,false);
    EndungRaute kompositionRaute= new EndungRaute("1..*","Rolle A",uk,true);
    EndungPfeil vererbungPfeil= new EndungPfeil("1..*","Rolle A",uk,false,true);
    EndungPfeil assoPfeil= new EndungPfeil("1..*","Rolle A",uk,false,false);
    UmlEinfacheVerbindung link= new UmlEinfacheVerbindung("meinLink","keine Zusicherung",standardLinie,aggregationRaute,leerEndung,0);
    UmlVererbung vererbung= new UmlVererbung("meineVererbung","keine Zusicherung",standardLinie,vererbungPfeil,leerEndung,"Stereo","disk");
    UmlAssoziation asso= new UmlAssoziation("meineAssoziation","x=1",standardLinie,leerEndung,assoPfeil,2,"Stereo");
  }
}