package Utopp.Pflichtenheft;

import Utopp.Komponenten.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;



public class EditPH extends JDialog implements ActionListener
        {
        Pflichtenheft PH;
        JTextArea ZielArea;
        JTextArea MussArea;
        JTextArea WunschArea;
        JTextArea AbgrenzungArea;
        JTextArea Software2Area;
        JTextArea Hardware2Area;
        JTextArea Orgware2Area;
        JTextArea Schnittstellen2Area;
        JTextArea AnwendungArea;
        JTextArea ZielgruppenArea;
        JTextArea BetriebArea;
        JTextArea UseCasesArea;
        JTextArea KlassenArea;
        JTextArea SoftwareArea;
        JTextArea HardwareArea;
        JTextArea OrgwareArea;
        JTextArea SchnittstellenArea;
        JTextArea LeistungenArea;
        JTextArea FunktionenArea;
        JTextArea ErgaenzungenArea;

        public EditPH(JFrame frame, boolean modal,Pflichtenheft PH)
                {
                super(frame,"Edit Pflichtenheft",modal);
                this.PH = PH;
                JPanel MainPanel = new JPanel();
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

                //TabbedPane
		gbc = makegbc(0,0,3,6);
		gbc.weightx = 100;
		gbc.weighty = 100;
		gbc.fill = GridBagConstraints.BOTH;
                JTabbedPane pane = new JTabbedPane();
                pane.addTab("Ziele",createZieleTab());
                pane.addTab("Produkt",createProduktTab());
                pane.addTab("Use-Cases",createUseCasesTab());
                pane.addTab("Klassen",createKlassenTab());
                pane.addTab("Produktleistungen",createProduktleistungenTab());
                pane.addTab("Entwicklungsumgebung",createUmgebungTab());
                pane.addTab("Ergnzungen",createErgaenzungenTab());
                gbl.setConstraints(pane,gbc);
                MainPanel.add(pane);

                // OK-Button
		gbc = makegbc(1,6,1,1);
		gbc.fill = GridBagConstraints.NONE;
		gbc.anchor = GridBagConstraints.SOUTH;
                JButton OKButton = new JButton("OK");
                OKButton.addActionListener(this);
                gbl.setConstraints(OKButton,gbc);
		MainPanel.add(OKButton);

                //Cancel-Button
		gbc = makegbc(2,6,1,1);
		gbc.fill = GridBagConstraints.NONE;
		gbc.anchor = GridBagConstraints.EAST;
		JButton CancelButton = new JButton("Cancel");
                CancelButton.addActionListener(this);
                gbl.setConstraints(CancelButton,gbc);
		MainPanel.add(CancelButton);

                Container cp = getContentPane();
                cp.add(MainPanel);
                //Damit man das Fenster schliessen kann
                this.addWindowListener(
				new WindowAdapter()
					{
					public void windowClosed(WindowEvent e)
						{
                                                killYourself();
                                                }
					}
				);

                }
                private GridBagConstraints makegbc(int x, int y, int width, int height)
			{
			GridBagConstraints gbc =  new GridBagConstraints();
			gbc.gridx = x;
			gbc.gridy = y;
			gbc.gridwidth = width;
			gbc.gridheight = height;
			gbc.insets = new Insets(2,2,2,2);
			return gbc;
			}

        private JPanel createZieleTab()
                {
                JPanel MainPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

                //Zielbestimmung
		gbc = makegbc(0,0,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Ziel = new JLabel("Zielbestimmung");
                gbl.setConstraints(Ziel,gbc);
                MainPanel.add(Ziel);

                //ZielArea
		gbc = makegbc(0,1,6,4);
                gbc.weightx = 200;
		gbc.weighty = 200;
                gbc.fill = GridBagConstraints.BOTH;
		ZielArea = new JTextArea(PH.getPHeft(0));
                ZielArea.setLineWrap(true);
                JScrollPane scroll1 = new JScrollPane(ZielArea);
                gbl.setConstraints(scroll1,gbc);
		MainPanel.add(scroll1);

                //Musskriterien
		gbc = makegbc(0,5,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Muss = new JLabel("Musskriterien");
                gbl.setConstraints(Muss,gbc);
                MainPanel.add(Muss);

                //MussArea
		gbc = makegbc(0,6,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		MussArea = new JTextArea(PH.getPHeft(1));
                MussArea.setLineWrap(true);
                JScrollPane scroll2 = new JScrollPane(MussArea);
                gbl.setConstraints(scroll2,gbc);
		MainPanel.add(scroll2);

                //Wunschkriterien
		gbc = makegbc(0,9,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Wunsch = new JLabel("Wunschkriterien");
                gbl.setConstraints(Wunsch,gbc);
                MainPanel.add(Wunsch);

                //WunschArea
		gbc = makegbc(0,10,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		WunschArea = new JTextArea(PH.getPHeft(2));
                WunschArea.setLineWrap(true);
                JScrollPane scroll3 = new JScrollPane(WunschArea);
                gbl.setConstraints(scroll3,gbc);
		MainPanel.add(scroll3);

                //Abgrenzungskriterien
		gbc = makegbc(0,13,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Abgrenzung = new JLabel("Abgrenzungskriterien");
                gbl.setConstraints(Abgrenzung,gbc);
                MainPanel.add(Abgrenzung);

                //AbgrenzungsArea
		gbc = makegbc(0,14,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		AbgrenzungArea = new JTextArea(PH.getPHeft(3));
                AbgrenzungArea.setLineWrap(true);
                JScrollPane scroll4 = new JScrollPane(AbgrenzungArea);
                gbl.setConstraints(scroll4,gbc);
		MainPanel.add(scroll4);
                return MainPanel;
                }
        private JPanel createProduktTab()
                {
                JPanel MainPanel = new JPanel();
                MainPanel.setLayout(new GridLayout(1,1));
                JTabbedPane SubPane = new JTabbedPane();

                JPanel UmgebungPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		UmgebungPanel.setLayout(gbl);

                //Software2
		gbc = makegbc(0,0,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Software2 = new JLabel("Software");
                gbl.setConstraints(Software2,gbc);
                UmgebungPanel.add(Software2);

                //Software2Area
		gbc = makegbc(0,1,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		Software2Area = new JTextArea(PH.getPHeft(7));
                Software2Area.setLineWrap(true);
                JScrollPane scroll5 = new JScrollPane(Software2Area);
                gbl.setConstraints(scroll5,gbc);
		UmgebungPanel.add(scroll5);

                //Hardware2
		gbc = makegbc(0,3,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Hardware2 = new JLabel("Hardware");
                gbl.setConstraints(Hardware2,gbc);
                UmgebungPanel.add(Hardware2);

                //Hardware2Area
		gbc = makegbc(0,4,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		Hardware2Area = new JTextArea(PH.getPHeft(8));
                Hardware2Area.setLineWrap(true);
                JScrollPane scroll6 = new JScrollPane(Hardware2Area);
                gbl.setConstraints(scroll6,gbc);
		UmgebungPanel.add(scroll6);

                //Orgware2
		gbc = makegbc(0,7,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Orgware2 = new JLabel("Orgware");
                gbl.setConstraints(Orgware2,gbc);
                UmgebungPanel.add(Orgware2);

                //Orgware2Area
		gbc = makegbc(0,8,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		Orgware2Area = new JTextArea(PH.getPHeft(9));
                Orgware2Area.setLineWrap(true);
                JScrollPane scroll7 = new JScrollPane(Orgware2Area);
                gbl.setConstraints(scroll7,gbc);
		UmgebungPanel.add(scroll7);

                //Schnittstellen2
		gbc = makegbc(0,11,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Schnittstellen2 = new JLabel("Schnittstellen");
                gbl.setConstraints(Schnittstellen2,gbc);
                UmgebungPanel.add(Schnittstellen2);

                //Schnittstellen2Area
		gbc = makegbc(0,12,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		Schnittstellen2Area = new JTextArea(PH.getPHeft(10));
                Schnittstellen2Area.setLineWrap(true);
                JScrollPane scroll8 = new JScrollPane(Schnittstellen2Area);
                gbl.setConstraints(scroll8,gbc);
		UmgebungPanel.add(scroll8);







                JPanel EinsatzPanel = new JPanel();
                GridBagLayout gbm = new GridBagLayout();
		EinsatzPanel.setLayout(gbm);

                //Anwendung
		gbc = makegbc(0,0,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Anwendung = new JLabel("Anwendungsbereiche");
                gbm.setConstraints(Anwendung,gbc);
                EinsatzPanel.add(Anwendung);

                //AnwendungArea
		gbc = makegbc(0,1,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		AnwendungArea = new JTextArea(PH.getPHeft(4));
                AnwendungArea.setLineWrap(true);
                JScrollPane scroll9 = new JScrollPane(AnwendungArea);
                gbm.setConstraints(scroll9,gbc);
		EinsatzPanel.add(scroll9);

                //Zielgruppen
		gbc = makegbc(0,3,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Zielgruppen = new JLabel("Zielgruppen");
                gbm.setConstraints(Zielgruppen,gbc);
                EinsatzPanel.add(Zielgruppen);

                //ZielgruppenArea
		gbc = makegbc(0,4,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		ZielgruppenArea = new JTextArea(PH.getPHeft(5));
                ZielgruppenArea.setLineWrap(true);
                JScrollPane scroll10 = new JScrollPane(ZielgruppenArea);
                gbm.setConstraints(scroll10,gbc);
		EinsatzPanel.add(scroll10);

                //Betriebsbedingungen
		gbc = makegbc(0,7,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Betrieb = new JLabel("Betriebsbedingungen");
                gbm.setConstraints(Betrieb,gbc);
                EinsatzPanel.add(Betrieb);

                //BetriebArea
		gbc = makegbc(0,8,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		BetriebArea = new JTextArea(PH.getPHeft(6));
                BetriebArea.setLineWrap(true);
                JScrollPane scroll11 = new JScrollPane(BetriebArea);
                gbm.setConstraints(scroll11,gbc);
		EinsatzPanel.add(scroll11);


                SubPane.addTab("Produkteinsatz",EinsatzPanel);
                SubPane.addTab("Produktumgebung",UmgebungPanel);
                MainPanel.add(SubPane);
                return MainPanel;
                }
        private JPanel createUseCasesTab()
                {
                JPanel MainPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

                //UseCases
		gbc = makegbc(0,0,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel UseCases = new JLabel("Use-Cases");
                gbl.setConstraints(UseCases,gbc);
                MainPanel.add(UseCases);

                //UseCasesArea
		gbc = makegbc(0,1,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		UseCasesArea = new JTextArea(PH.getPHeft(11));
                UseCasesArea.setLineWrap(true);
                JScrollPane scroll12 = new JScrollPane(UseCasesArea);
                gbl.setConstraints(scroll12,gbc);
		MainPanel.add(scroll12);
                return MainPanel;
                }
        private JPanel createKlassenTab()
                {
                JPanel MainPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

                //Klassen
		gbc = makegbc(0,0,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Klassen = new JLabel("Klassen");
                gbl.setConstraints(Klassen,gbc);
                MainPanel.add(Klassen);

                //KlassenArea
		gbc = makegbc(0,1,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		KlassenArea = new JTextArea(PH.getPHeft(12));
                KlassenArea.setLineWrap(true);
                JScrollPane scroll13 = new JScrollPane(KlassenArea);
                gbl.setConstraints(scroll13,gbc);
		MainPanel.add(scroll13);
                return MainPanel;
                }
        private JPanel createErgaenzungenTab()
                {
                JPanel MainPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

                //Ergnzungen
		gbc = makegbc(0,0,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Ergaenzungen = new JLabel("Ergnzungen");
                gbl.setConstraints(Ergaenzungen,gbc);
                MainPanel.add(Ergaenzungen);

                //ErgaenzungenArea
		gbc = makegbc(0,1,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		ErgaenzungenArea = new JTextArea(PH.getPHeft(19));
                ErgaenzungenArea.setLineWrap(true);
                JScrollPane scroll21 = new JScrollPane(ErgaenzungenArea);
                gbl.setConstraints(scroll21,gbc);
		MainPanel.add(scroll21);
                return MainPanel;
                }
  private JPanel createProduktleistungenTab()
                {
                JPanel MainPanel = new JPanel();
                MainPanel.setLayout(new GridLayout(1,1));
                JTabbedPane SubPane = new JTabbedPane();

                JPanel FunktionenPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		FunktionenPanel.setLayout(gbl);

                //Funktionen
		gbc = makegbc(0,0,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Funktionen = new JLabel("Funktionen");
                gbl.setConstraints(Funktionen,gbc);
                FunktionenPanel.add(Funktionen);

                //FunktionenArea
		gbc = makegbc(0,1,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		FunktionenArea = new JTextArea(PH.getPHeft(13));
                FunktionenArea.setLineWrap(true);
                JScrollPane scroll19 = new JScrollPane(FunktionenArea);
                gbl.setConstraints(scroll19,gbc);
		FunktionenPanel.add(scroll19);


                JPanel LeistungenPanel = new JPanel();
                GridBagLayout gbm = new GridBagLayout();
		LeistungenPanel.setLayout(gbm);

                //Leistungen
		gbc = makegbc(0,0,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Leistungen = new JLabel("Leistungen");
                gbm.setConstraints(Leistungen,gbc);
                LeistungenPanel.add(Leistungen);

                //LeistungenArea
		gbc = makegbc(0,1,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		LeistungenArea = new JTextArea(PH.getPHeft(14));
                LeistungenArea.setLineWrap(true);
                JScrollPane scroll20 = new JScrollPane(LeistungenArea);
                gbm.setConstraints(scroll20,gbc);
		LeistungenPanel.add(scroll20);


                SubPane.addTab("Funktionen",FunktionenPanel);
                SubPane.addTab("Leistungen",LeistungenPanel);
                MainPanel.add(SubPane);
                return MainPanel;
                }
        private JPanel createUmgebungTab()
                {
                   JPanel MainPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

                //Software
		gbc = makegbc(0,0,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Software = new JLabel("Software");
                gbl.setConstraints(Software,gbc);
                MainPanel.add(Software);

                //SoftwareArea
		gbc = makegbc(0,1,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		SoftwareArea = new JTextArea(PH.getPHeft(15));
                SoftwareArea.setLineWrap(true);
                JScrollPane scroll14 = new JScrollPane(SoftwareArea);
                gbl.setConstraints(scroll14,gbc);
		MainPanel.add(scroll14);

                //Hardware
		gbc = makegbc(0,3,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Hardware = new JLabel("Hardware");
                gbl.setConstraints(Hardware,gbc);
                MainPanel.add(Hardware);

                //HardwareArea
		gbc = makegbc(0,4,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		HardwareArea = new JTextArea(PH.getPHeft(16));
                HardwareArea.setLineWrap(true);
                JScrollPane scroll15 = new JScrollPane(HardwareArea);
                gbl.setConstraints(scroll15,gbc);
		MainPanel.add(scroll15);

                //Orgware
		gbc = makegbc(0,7,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Orgware = new JLabel("Orgware");
                gbl.setConstraints(Orgware,gbc);
                MainPanel.add(Orgware);

                //OrgwareArea
		gbc = makegbc(0,8,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		OrgwareArea = new JTextArea(PH.getPHeft(17));
                OrgwareArea.setLineWrap(true);
                JScrollPane scroll16 = new JScrollPane(OrgwareArea);
                gbl.setConstraints(scroll16,gbc);
		MainPanel.add(scroll16);

                //Schnittstellen
		gbc = makegbc(0,11,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel Schnittstellen = new JLabel("Schnittstellen");
                gbl.setConstraints(Schnittstellen,gbc);
                MainPanel.add(Schnittstellen);

                //SchnittstellenArea
		gbc = makegbc(0,12,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		SchnittstellenArea = new JTextArea(PH.getPHeft(18));
                SchnittstellenArea.setLineWrap(true);
                JScrollPane scroll17 = new JScrollPane(SchnittstellenArea);
                gbl.setConstraints(scroll17,gbc);
		MainPanel.add(scroll17);
                return MainPanel;
                }

        private void killYourself()
                {
                this.setVisible(false);
                this.hide();
                }
        public void actionPerformed(ActionEvent event)
                {
                String command = event.getActionCommand();
                if (command.equals("OK"))
                        {
                        //Speichere alle Daten in Pflichtenheft ab
                        PH.setPHeft(0 ,ZielArea.getText());
                        PH.setPHeft(1 ,MussArea.getText());
                        PH.setPHeft(2 ,WunschArea.getText());
                        PH.setPHeft(3 ,AbgrenzungArea.getText());
                        PH.setPHeft(4 ,AnwendungArea.getText());
                        PH.setPHeft(5 ,ZielgruppenArea.getText());
                        PH.setPHeft(6 ,BetriebArea.getText());
                        PH.setPHeft(7 ,Software2Area.getText());
                        PH.setPHeft(8 ,Hardware2Area.getText());
                        PH.setPHeft(9 ,Orgware2Area.getText());
                        PH.setPHeft(10,Schnittstellen2Area.getText());
                        PH.setPHeft(11,UseCasesArea.getText());
                        PH.setPHeft(12,KlassenArea.getText());
                        PH.setPHeft(13,FunktionenArea.getText());
                        PH.setPHeft(14,LeistungenArea.getText());
                        PH.setPHeft(15,SoftwareArea.getText());
                        PH.setPHeft(16,HardwareArea.getText());
                        PH.setPHeft(17,OrgwareArea.getText());
                        PH.setPHeft(18,SchnittstellenArea.getText());
                        PH.setPHeft(19,ErgaenzungenArea.getText());


                        //Beende Dialog
                        killYourself();
                        }
                if (command.equals("Cancel"))
                        {
                        //Beende Dialog
                        killYourself();
                        }
                }
        }
