package Utopp.Pflichtenheft;

import Utopp.Komponenten.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;


public class ShowPH extends JDialog implements ActionListener
        {

        Pflichtenheft PH;
        final String MainTab = "\t\t";
        final String SubTab = "\t\t\t";

        public ShowPH(JFrame frame, boolean modal, Pflichtenheft PH)
                {
                super(frame,"Ausgabe des Pflichtenheftes",modal);
                this.PH = PH;
                Container cp = getContentPane();

                JPanel MainPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

                //AusgabeArea
		gbc = makegbc(0,0,5,4);
                gbc.weightx = 200;
		gbc.weighty = 200;
                gbc.fill = GridBagConstraints.BOTH;
                JTextArea AusgabeArea = new JTextArea();
                JScrollPane scroll = new JScrollPane(AusgabeArea);
                gbl.setConstraints(scroll,gbc);
                MainPanel.add(scroll);

                //Button
		gbc = makegbc(3,4,1,1);
                gbc.anchor = GridBagConstraints.SOUTH;
                gbc.fill = GridBagConstraints.NONE;
                JButton OK = new JButton("OK");
                OK.addActionListener(this);
                gbl.setConstraints(OK,gbc);
                MainPanel.add(OK);

                 // Einlesen der Werte
                 AusgabeArea.setTabSize(2);
                 AusgabeArea.append("1) Zielbestimmungen:" + setText(MainTab,PH.getPHeft(0)));
                 AusgabeArea.append("\t" + "1.1) Mukriterien:" + setText(SubTab,PH.getPHeft(1)));
                 AusgabeArea.append("\t" + "1.2) Wunschkriterien:" + setText(MainTab,PH.getPHeft(2)));
                 AusgabeArea.append("\t" + "1.3) Abgrenzungskriterien:" + setText(MainTab,PH.getPHeft(3)));
                 AusgabeArea.append("\n2) Produkteinsatz:\n");
                 AusgabeArea.append("\t" + "2.1) Anwendungsbereiche:" + setText(SubTab,PH.getPHeft(4)));
                 AusgabeArea.append("\t" + "2.2) Zielgruppen:" + setText(SubTab,PH.getPHeft(5)));
                 AusgabeArea.append("\t" + "2.3) Betriebsbedingungen:" + setText(SubTab,PH.getPHeft(6)));
                 AusgabeArea.append("\n3) Produktumgebung:\n");
                 AusgabeArea.append("\t" + "3.1) Software:" + setText(SubTab,PH.getPHeft(7)));
                 AusgabeArea.append("\t" + "3.2) Hardware:" + setText(SubTab,PH.getPHeft(8)));
                 AusgabeArea.append("\t" + "3.3) Orgware:"+setText(SubTab,PH.getPHeft(9)));
                 AusgabeArea.append("\t" + "3.4) Schnittstellen:"+setText(SubTab,PH.getPHeft(10)));
                 AusgabeArea.append("\n4) Produktinformation(UseCases):"+setText(MainTab,PH.getPHeft(11)));
                 AusgabeArea.append("\n5) Produktdaten(Klassen):"+setText(MainTab,PH.getPHeft(12)));
                 // Einsparnisse
                 AusgabeArea.append("\n6) Entwicklungsumgebung:\n");
                 AusgabeArea.append("\t" + "6.1) Software:"+setText(SubTab,PH.getPHeft(15)));
                 AusgabeArea.append("\t" + "6.2) Hardware:"+setText(SubTab,PH.getPHeft(16)));
                 AusgabeArea.append("\t" + "6.3) Orgware:"+setText(SubTab,PH.getPHeft(17)));
                 AusgabeArea.append("\t" + "6.4) Schnittstellen:"+setText(SubTab,PH.getPHeft(18)));
                 AusgabeArea.append("\n7) Ergnzungen:"+setText(MainTab,PH.getPHeft(19)));
                // Einlesen beendet

                AusgabeArea.setEditable(false);
                AusgabeArea.setLineWrap(true);

                cp.add(MainPanel);

                //Damit man das Fenster schliessen kann
                this.addWindowListener(
				new WindowAdapter()
					{
					public void windowClosed(WindowEvent e)
						{
                                                killYourself();
                                                }
					}
				);

                }

                private String setText(String Tabs, String Text)
                        {
                        String tmp = "";
                        int counter = 0;
                        int newcounter = 0;
                        //System.out.println("String: "+Text);

                        if ((Text.lastIndexOf("\n")) == -1)
                                {
                                //System.out.println("Keine \\n vorhanden");
                                tmp = "\n" + Tabs + Text + "\n";
                                }
                        else
                                {
                                while (newcounter < Text.lastIndexOf("\n"))
                                        {
                                        //System.out.println("\\n vorhanden; Counter : "+counter+" Newcounter: "+newcounter);
                                        //System.out.println(tmp);
                                        newcounter = Text.indexOf("\n",counter);
                                        tmp = tmp + "\n" + Tabs + Text.substring(counter,newcounter);
                                        counter = newcounter+1;
                                        }
                                tmp = tmp + "\n" + Tabs + Text.substring(newcounter+1,Text.length()) + "\n";
                                }
                        return tmp;
                        }


                private GridBagConstraints makegbc(int x, int y, int width, int height)
			{
			GridBagConstraints gbc =  new GridBagConstraints();
			gbc.gridx = x;
			gbc.gridy = y;
			gbc.gridwidth = width;
			gbc.gridheight = height;
			gbc.insets = new Insets(2,2,2,2);
			return gbc;
			}


        private void killYourself()
                {
                this.setVisible(false);
                this.hide();
                }
        public void actionPerformed(ActionEvent event)
                {
                String command = event.getActionCommand();
                if (command.equals("OK"))
                        {
                        //Beende Dialog
                        killYourself();
                        }

                }
        }
