package Utopp.UseCase;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import Utopp.Komponenten.*;

public class EditUC extends JDialog implements ActionListener
        {
	UmlUseCase usecase;
  	JTextField TextNummer;
        TTextArea TAreaAkteur;
        JTextArea TextName;
        TTextArea TAreaVorbedingung;
        TTextArea TAreaNachbedingung;
        TTextArea TAreaInvariant;
        TTextArea TAreaNichtfun;
        TTextArea TAreaAblauf;
        TTextArea TAreaAusnahmen;
	TTextArea TAreaRegel;
        TTextArea TAreaService;
        TTextArea TAreaAnmerkung;
        TTextArea TAreaAnsprech;



         public EditUC(JFrame frame, boolean modal,UmlUseCase usecase)
                {
                super(frame,"UseCase editieren",modal);
                this.usecase = usecase;

      	  	JPanel MainPanel = new JPanel();
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);


                //TabbedPane
		gbc = makegbc(0,0,3,6);
		gbc.weightx = 100;
		gbc.weighty = 100;
		gbc.fill = GridBagConstraints.BOTH;
                JTabbedPane pane = new JTabbedPane();
                pane.addTab("Info",createInfoTab());
                pane.addTab("Bedingung",createBedingungTab());
                pane.addTab("Ablauf",createAblaufTab());
                pane.addTab("Sonstiges",createSonstigesTab());
		gbl.setConstraints(pane,gbc);
                MainPanel.add(pane);

                // OK-Button
		gbc = makegbc(1,6,1,1);
		gbc.fill = GridBagConstraints.NONE;
		gbc.anchor = GridBagConstraints.SOUTH;
                JButton OKButton = new JButton("OK");
                OKButton.addActionListener(this);
                gbl.setConstraints(OKButton,gbc);
		MainPanel.add(OKButton);

                //Cancel-Button
		gbc = makegbc(2,6,1,1);
		gbc.fill = GridBagConstraints.NONE;
		gbc.anchor = GridBagConstraints.EAST;
		JButton CancelButton = new JButton("Cancel");
                CancelButton.addActionListener(this);
                gbl.setConstraints(CancelButton,gbc);
		MainPanel.add(CancelButton);

                Container cp = getContentPane();
                cp.add(MainPanel);
                //Damit man das Fenster schliessen kann
                this.addWindowListener(
				new WindowAdapter()
					{
					public void windowClosed(WindowEvent e)
						{
                                                killYourself();
                                                }
					}
				);

                }
                private GridBagConstraints makegbc(int x, int y, int width, int height)
			{
			GridBagConstraints gbc =  new GridBagConstraints();
			gbc.gridx = x;
			gbc.gridy = y;
			gbc.gridwidth = width;
			gbc.gridheight = height;
			gbc.insets = new Insets(2,2,2,2);
			return gbc;
			}


        private JPanel createInfoTab()
                {
                JPanel MainPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

		//Use Case Label Nummer
                gbc = makegbc(0,1,6,1) ;
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelNummer = new JLabel("Nummer");
                gbl.setConstraints(LabelNummer,gbc);
                MainPanel.add(LabelNummer);

		//Use case nummer Feld
                gbc = makegbc(0, 2, 6, 1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                TextNummer = new JTextField(usecase.getUC(0));
                gbl.setConstraints(TextNummer, gbc);
                MainPanel.add(TextNummer);

		//Label Name
		gbc = makegbc(0,3,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelName = new JLabel("Name");
                gbl.setConstraints(LabelName,gbc);
                MainPanel.add(LabelName);
                //Text Name
                gbc = makegbc (0,4,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                TextName = new JTextArea(usecase.getUC(1));
                gbl.setConstraints(TextName, gbc);
                MainPanel.add(TextName);

                //Label Akteur
                 gbc = makegbc(0,5,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelAkteur = new JLabel("Akteur(e)");
                gbl.setConstraints(LabelAkteur,gbc);
                MainPanel.add(LabelAkteur);

                //Unser Akteur TextArea
		gbc = makegbc(0,6,6,4);
                gbc.weightx = 200;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		TAreaAkteur = new TTextArea(usecase.getUC(2));
                //TAreaAkteur.setLineWrap(true);
                //TAreaAkteur.setWrapStyleWord(true);
                JScrollPane scroll1 = new JScrollPane(TAreaAkteur);
		gbl.setConstraints(scroll1,gbc);
		MainPanel.add(scroll1);



                return MainPanel;

                }

        	private JPanel createBedingungTab()
                {
                JPanel MainPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

                //Vorbedingung Label
                gbc = makegbc(0,1,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelVorbedingung = new JLabel("Vorbedingung(en)");
                gbl.setConstraints(LabelVorbedingung,gbc);
                MainPanel.add(LabelVorbedingung);

                //Text Vorbedingung

                gbc = makegbc(0,2,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		TAreaVorbedingung = new TTextArea(usecase.getUC(3));

		JScrollPane scroll2 = new JScrollPane(TAreaVorbedingung);
		gbl.setConstraints(scroll2,gbc);
		MainPanel.add(scroll2);

                //Label Nachbedingung
                gbc = makegbc(0,5,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelNachbedingung = new JLabel("Nachbedingung(en)");
                gbl.setConstraints(LabelNachbedingung,gbc);
                MainPanel.add(LabelNachbedingung);

                //Text Nachbedingung

                gbc = makegbc(0,6,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		TAreaNachbedingung = new TTextArea(usecase.getUC(4));
                TAreaNachbedingung.setLineWrap(true);
		JScrollPane scroll3 = new JScrollPane(TAreaNachbedingung);
		gbl.setConstraints(scroll3,gbc);
		MainPanel.add(scroll3);

                //Label Invarianten
                gbc = makegbc(0,9,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelInvariant = new JLabel("Invarianten");
                gbl.setConstraints(LabelInvariant,gbc);
                MainPanel.add(LabelInvariant);

                //Text Invarianten
                gbc = makegbc(0,10,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;

		gbc.fill = GridBagConstraints.BOTH;
		TAreaInvariant = new TTextArea(usecase.getUC(5));
		JScrollPane scroll4 = new JScrollPane(TAreaInvariant);
		gbl.setConstraints(scroll4,gbc);
		MainPanel.add(scroll4);

                //Label nichtfunktionale Anforderungen
                gbc = makegbc(0,13,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelNichtfun = new JLabel("nichtfunktionale Anforderungen");
                gbl.setConstraints(LabelNichtfun,gbc);
                MainPanel.add(LabelNichtfun);

                //Text nichtfunktionale Anforderungen
                gbc = makegbc(0,14,6,4);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		TAreaNichtfun = new TTextArea(usecase.getUC(6));
		JScrollPane scroll5 = new JScrollPane(TAreaNichtfun);
		gbl.setConstraints(scroll5,gbc);
		MainPanel.add(scroll5);


		return MainPanel;
                }
        private JPanel createAblaufTab()
                {
                JPanel MainPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

                //Label Ablauf
                gbc = makegbc(0,1,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelAblauf = new JLabel("Ablaufbeschreibung");
                gbl.setConstraints(LabelAblauf,gbc);
                MainPanel.add(LabelAblauf);

                //Text Ablauf

                gbc = makegbc(0,2,6,4);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		TAreaAblauf = new TTextArea(usecase.getUC(7));
		JScrollPane scroll6 = new JScrollPane(TAreaAblauf);
		gbl.setConstraints(scroll6,gbc);
		MainPanel.add(scroll6);


                //Label Ausnahmen

                gbc = makegbc(0,7,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelAusnahmen = new JLabel("Ausnahmen und Fehler");
                gbl.setConstraints(LabelAusnahmen,gbc);
                MainPanel.add(LabelAusnahmen);

                //Text Ausnahmen

                gbc = makegbc(0,8,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		TAreaAusnahmen = new TTextArea(usecase.getUC(8));
		JScrollPane scroll7 = new JScrollPane(TAreaAusnahmen);
		gbl.setConstraints(scroll7,gbc);
		MainPanel.add(scroll7);

                //Label Regeln

                gbc = makegbc(0,11,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelRegel = new JLabel("Regeln");
                gbl.setConstraints(LabelRegel,gbc);
                MainPanel.add(LabelRegel);

                //Text Regeln

                gbc = makegbc(0,12,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		TAreaRegel = new TTextArea(usecase.getUC(9));
		JScrollPane scroll8 = new JScrollPane(TAreaRegel);
		gbl.setConstraints(scroll8,gbc);
		MainPanel.add(scroll8);

                //Label Services

                gbc = makegbc(0,15,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelService = new JLabel("Services");
                gbl.setConstraints(LabelService,gbc);
                MainPanel.add(LabelService);

                //Text Services

                gbc = makegbc(0,16,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		TAreaService = new TTextArea(usecase.getUC(10));
		JScrollPane scroll9 = new JScrollPane(TAreaService);
		gbl.setConstraints(scroll9,gbc);
		MainPanel.add(scroll9);

                return MainPanel;
                }
        private JPanel createSonstigesTab()
                {
                JPanel MainPanel = new JPanel();
                GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		MainPanel.setLayout(gbl);

                //Label Anmerkungen
                gbc = makegbc(0,1,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelAnmerkung = new JLabel("Anmerkungen");
                gbl.setConstraints(LabelAnmerkung,gbc);
                MainPanel.add(LabelAnmerkung);

                //Text Anmerkungen

                gbc = makegbc(0,2,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		TAreaAnmerkung = new TTextArea(usecase.getUC(11));
		JScrollPane scroll10 = new JScrollPane(TAreaAnmerkung);
		gbl.setConstraints(scroll10,gbc);
		MainPanel.add(scroll10);

                //Label Ansprechpartner
                gbc = makegbc(0,5,6,1);
                gbc.anchor = GridBagConstraints.WEST;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                JLabel LabelAnsprech = new JLabel("Ansprechpartner");
                gbl.setConstraints(LabelAnsprech,gbc);
                MainPanel.add(LabelAnsprech);

                gbc = makegbc(0,6,6,2);
                gbc.weightx = 100;
		gbc.weighty = 100;
                gbc.fill = GridBagConstraints.BOTH;
		TAreaAnsprech = new TTextArea(usecase.getUC(12));
		JScrollPane scroll11 = new JScrollPane(TAreaAnsprech);
		gbl.setConstraints(scroll11,gbc);
		MainPanel.add(scroll11);


                return MainPanel;
                }
        private void killYourself()
                {
                this.setVisible(false);
                this.hide();
                }
        public void actionPerformed(ActionEvent event)
                {
                String command = event.getActionCommand();
                if (command.equals("OK"))
                        {

                        //Speichere alle Daten in UmlUC ab
 			usecase.setUC(0,TextNummer.getText());
                       	usecase.setUC(1,TextName.getText());
                	usecase.setUC(2,TAreaAkteur.getText());
			usecase.setUC(3,TAreaVorbedingung.getText());
                      	usecase.setUC(4,TAreaNachbedingung.getText());
                      	usecase.setUC(5,TAreaInvariant.getText());
                      	usecase.setUC(6,TAreaNichtfun.getText());
                      	usecase.setUC(7,TAreaAblauf.getText());
	                usecase.setUC(8,TAreaAusnahmen.getText());
                      	usecase.setUC(9,TAreaRegel.getText());
                      	usecase.setUC(10,TAreaService.getText());
                      	usecase.setUC(11,TAreaAnmerkung.getText());
                      	usecase.setUC(12,TAreaAnsprech.getText());
                        //hide();

                        //Beende Dialog
                        killYourself();
                        }
                if (command.equals("Cancel"))
                        {
                        //Beende Dialog
                        killYourself();
                        }
                }
        }

