package Utopp;
import javax.swing.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import Utopp.Komponenten.*;
import Utopp.Verbindung.*;



public class MainVb extends CloseableJFrame implements ActionListener
	{
	static MainVb frame;
        static Dimension dim;
        Container cp;
	public static UmlVerbindung verbindung;
        static boolean edited = false;

	MainVb()
		{
                super("Verbindungen");
                cp = getContentPane();
                cp.setLayout(new FlowLayout());
                JButton Load   = new JButton("Load");
                Load.addActionListener(this);
                JButton Save   = new JButton("Save");
                Save.addActionListener(this);
                JButton Edit   = new JButton("Edit");
                Edit.addActionListener(this);
                JButton New    = new JButton("New");
                New.addActionListener(this);
                JButton Delete = new JButton("Delete");
                Delete.addActionListener(this);
                JButton Quit   = new JButton("Quit");
                Quit.addActionListener(this);
                JButton Show   = new JButton("Show");
                Show.addActionListener(this);
                cp.add(New);
                cp.add(Edit);
                cp.add(Delete);
                cp.add(Show);
                cp.add(Load);
                cp.add(Save);
                cp.add(Quit);
                }

	public void actionPerformed(ActionEvent event)
		{
		String command = event.getActionCommand();
		if (command.equals("Quit"))
			{
			killYourself();
			}
		if (command.equals("Load"))
			{
                        loadInstance();
                        }
		if (command.equals("Save"))
			{
                        saveInstance();
			}
                if (command.equals("Edit"))
                        {
                        editInstance();
                        }
                if (command.equals("Show"))
                        {
                        showInstance();
                        }
                if (command.equals("New"))
                        {
                        createNewInstance();
                        }
                if (command.equals("Delete"))
                        {
                        deleteInstance();
                        }
                }

        private void createNewInstance()
                {
                //erzeuge neue Instanz

                verbindung = new UmlVerbindung();

                       //Das ist eine TestdefaultKomponente...
                        UmlKomponente uk= new UmlKomponente("blup");
                        UmlUseCase uuc = new UmlUseCase("UC1");
                    	LinienTyp standardLinie= new LinienTyp(1,true);
    			Endung leerEndung= new Endung(null,null,null);
    			Endung linkEndung= new Endung("1..*","Rolle A",uk);
    			EndungRaute aggregationRaute = new EndungRaute("1..*","Rolle A",uk,true);
    			//EndungRaute kompositionRaute= new EndungRaute("1..*","Rolle A",uk,true);
    			EndungPfeil vererbungPfeil= new EndungPfeil("1..*","Rolle A",uk,true,true);
			EndungPfeil assoPfeil= new EndungPfeil("1..*","Rolle A",uk,false,false);
			UmlEinfacheVerbindung link= new UmlEinfacheVerbindung("meinLink","keine Zusicherung",standardLinie,vererbungPfeil,assoPfeil,0);
    			//UmlVererbung vererbung= new UmlVererbung("meineVererbung","keine Zusicherung",standardLinie,vererbungPfeil,leerEndung,"Stereo","disk");
    			//UmlAssoziation asso= new UmlAssoziation("meineAssoziation","x=1",standardLinie,leerEndung,assoPfeil,2,"Stereo");
                        verbindung = link;

                //Finde Namen heraus
                //String Name = (String)JOptionPane.showInputDialog(frame,"Bitte einen Namen eingeben");
                //usecase.setName(Name);
                editInstance();
                edited = true;
                }
        private void editInstance()
                {
               // System.out.println("MainVB Name der Verbindung vor dem if ! " + verbindung.getName());
                //System.out.println("MainVB Name der Verbindung vor dem if " + ((LinienTyp)verbindung.getLinie()).getDurchgezogen());
                if (verbindung != null)
                        {
                        EditVb EditKlasse = new EditVb(frame,true,verbindung);
                        EditKlasse.setLocation(((dim.width - 400)/2),((dim.height-500)/2));
                        EditKlasse.setSize(350,350);
                        EditKlasse.setVisible(true);
                        //EditKlasse.show();
                        System.out.println("MainVb " + verbindung.getKompTyp());
                        System.out.println("MainVB Name der Verbindung" + verbindung.getName());
                        edited = true;
                        }
                }
        private void showInstance()
                {
                if (verbindung != null)
                        {

                        UmlVerbindungZeigen ShowKlasse = new UmlVerbindungZeigen(frame,true,verbindung);
                        ShowKlasse.setLocation(((dim.width - 600)/2),((dim.height-500)/2));
                        /*
			ShowKlasse.setSize(600,500);
                        ShowKlasse.setVisible(true);
                        */
			}
                }
        private void loadInstance()
                {
                if (edited)
                        {
                        int Auswahl = JOptionPane.showConfirmDialog(frame,"Soll wirklich eine Verbindung geladen werden?\n(Das Alte wurde noch nicht gespeichert)","Achtung",JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
                        if (Auswahl == JOptionPane.YES_OPTION)
                                {
                                loadMethod();
                                }
                        if (Auswahl == JOptionPane.NO_OPTION)
                                {
                                }
                        }
                else
                        {
                        loadMethod();
                        }
                }

        private void loadMethod()
                {
                //Ermittle den Pfad und den Namen des zu ladenen Objekts
                JFileChooser chooser = new JFileChooser();
                int returnVal = chooser.showOpenDialog(frame);
                if (returnVal == JFileChooser.APPROVE_OPTION)
                        {
                        File Path = chooser.getSelectedFile();
                        //Lade Objekt in den Speicher
                        try
                                {
                                FileInputStream fs = new FileInputStream(Path);
                                ObjectInputStream is = new ObjectInputStream(fs);
                                verbindung = (UmlVerbindung)is.readObject();
                                is.close();
                                }
                        catch (ClassNotFoundException e)
                                {
                                System.out.println("Class not found");
                                }
                        catch (IOException e)
                                {
                                System.out.println("IOException");
                                }

                        //Es braucht nicht gespeichert zu werden
                        edited = false;
                        }
                else
                        {
                        }
                }

        private static void saveInstance()
                {
                if (edited)
                        {
                        //Ermittle den Pfad und den Namen des zu ladenen Objekts
                        JFileChooser chooser = new JFileChooser();
                        int returnVal = chooser.showSaveDialog(frame);
                        if (returnVal == JFileChooser.APPROVE_OPTION)
                                {
                                File Path = chooser.getSelectedFile();
                                //Speichere Objekt auf externen Datentrger
                                try
                                        {
                                        FileOutputStream fs = new FileOutputStream(Path);
                                        ObjectOutputStream os = new ObjectOutputStream(fs);
                                        os.writeObject(verbindung);
                                        os.close();
                                        }
                                catch (IOException e)
                                        {
                                        System.out.println("Fehler beim Speichern");
                                        }
                                //Es braucht nicht noch einmal gespeichert werden
                                edited = false;
                                }
                        else
                                {
                                }
                        }
                }
        private void deleteInstance()
                {
                verbindung = null;
                edited = true;
                }
        public static void killYourself()
                {
                //Wurde bereits gespeichert?
                if (edited)
                        {
                        //Frage nach, ob gespeichert werden soll
                        int Auswahl = JOptionPane.showConfirmDialog(frame,"Soll vor dem Beenden das Objekt gespeichert werden?","Achtung",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE);
                        if (Auswahl == JOptionPane.YES_OPTION)
                                {
                                saveInstance();
                                System.exit(0);
                                }
                        if (Auswahl == JOptionPane.NO_OPTION)
                                {
                                System.exit(0);
                                }
                        if (Auswahl == JOptionPane.CANCEL_OPTION)
                                {
                                }
                        }
                else
                        {
                        System.exit(0);
                        }
                }


	public static void main(String[] args)
		{
		dim = Toolkit.getDefaultToolkit().getScreenSize();
		frame = new MainVb();
		frame.addWindowListener(
				new WindowAdapter()
					{
					public void windowClosed(WindowEvent e)
						{
                                                killYourself();
                                                }
					}
				);
                int paneX = (dim.width - 300) / 2 ;
		int paneY = (dim.height - 100) / 2 ;
		frame.setLocation(paneX,paneY);
		frame.setSize(300,100);
		frame.setVisible(true);
                }
	}